# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

import sys
import time
from os.path import join as opj

from atop import store
from atop import credup

from twisted.python import log

AVATARS_PER_TRANSACTION = 3
AVATAR_TRANSACTIONS = 6

ITEMS_PER_AVATAR = 9

INTERVAL = 0.0001

def write(*s):
    print ' '.join(map(str, s))
    sys.stdout.flush()

def sleep():
    time.sleep(INTERVAL)

def main(base):
    write('About to create store')
    s = store.Store(0, opj(base, 'db'), opj(base, 'files'))
    write('Created the store')
    
    aIDs = []
    def _(b):
        for i in range(AVATARS_PER_TRANSACTION):
            aIDs.append(credup.Avatar(s, name="Avatar %d (foo)" % (b + i)).storeID)
    for i in range(AVATAR_TRANSACTIONS):
        low = i * AVATARS_PER_TRANSACTION
        write('About to create avatars', low, low + AVATARS_PER_TRANSACTION)
        s.transact(_, low)
        write('Avatar IDs', ' '.join(map(str, aIDs)))
        aIDs = []
        sleep()
    
    write('About to load avatars')
    avs = []
    for id in aIDs:
        avs.append(s.getItemByID(id))
    write('Loaded the avatars')
    
    iIDs = []
    def _(a):
        for i in range(ITEMS_PER_AVATAR):
            iIDs.append(store.Item(a, name="Item %d of Avatar %d" % (i, a.storeID)).storeID)
    for a in avs:
        write('About to create items for', a.storeID)
        a.transact(_, a)
        write('Item IDs', ' '.join(map(str, iIDs)))
        sleep()

if __name__ == '__main__':
    main(sys.argv[1])
