from atop.powerup import Powerup, IPowerStation
import formless
from twisted.python.reflect import namedClass

class IGradeup(formless.TypedInterface):
    def loadPowerup(self, powerup=formless.String()):
        "Load the named powerup."
    loadPowerup=formless.autocallable(loadPowerup)

    def loadMailingLists(self):
        """Load mailing list filer and process all back messages"""
    loadMailingLists = formless.autocallable(loadMailingLists)

class Gradeup(Powerup):
    __implements__ = Powerup.__implements__, IGradeup
    powerupName = 'Cheap Powerup Loading Trick'

    def loadPowerup(self, powerup):
        try:
            pup = namedClass(powerup)
        except (ImportError, AttributeError):
            return "I couldn't find that class."
        pm = IPowerStation(self.store)
        def _():
            pm.installPowerup(pup)
        self.store.transact(_)

    def loadMailingLists(self):
        from quotient.smarts.list import MailingListFiler
        from quotient.smartenup import retroactivelyExtract
        from quotient import prefup

        def _():
            mlf, d = retroactivelyExtract(self.store, MailingListFiler)
            prefup.IPrefs(self.store).addToPrimaryNav(mlf.extractPool())
        self.store.transact(_)

        return "Now filtering mailing list posts"
