# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

from os.path import join as opj
import os.path as osp

from quotient import web

from twisted.python import log
from twisted.python.components import Adapter, Interface


class IHelpText(Interface):
    """I allow you to find the appropriate contextual help
    text for a given object
    """

helpfiles = opj(osp.split(web.__file__)[0], 'help')

def _readIfExists(pth):
    """return a files contents if it exists, otherwise return None"""
    if osp.exists(pth):
        return file(pth, 'r').read()
    # log.msg('help path %s exists not! boo!' % pth)
    return None

def MIMEMessageHelp(original):
    return _readIfExists(opj(helpfiles, 'MIMEMessage.html'))
        
        
def NameAttributeBasedHelp(original):
    """generate help file name based on the original objects .name attribute"""
    return _readIfExists(opj(helpfiles, original.name.replace(' ', '') + '.html'))


def ClassNameBasedHelp(original):
    """generate help file name based on the original objects.__class__.__name__"""
    return _readIfExists(opj(helpfiles, original.__class__.__name__ + '.html'))

