# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

from twisted.spread import pb
from twisted.cred import checkers

from atop import credup
from atop import powerup

PBServerFactory = pb.PBServerFactory

class PBUp(powerup.Powerup, pb.Perspective):
    def setUpPools(self, st):
        st.setComponent(pb.IPerspective, self)

    def perspective_createUser(self, username, password, domain):
        def _():
            a = credup.Avatar(self.store.store, username)
            a.setSecurePassword(password)
            checkers.ICredentialsChecker(self.store.store).addAvatar(a, domain)
        self.store.transact(_)
