
from atop.sched import SubScheduler
from atop.credup import StoreRealm

from quotient.commander import Commander
from quotient.signup import BoxOffice
from quotient.sysup import Sysup
from quotient.proto.imapup import IMAPAccountUp
from quotient.proto.smtpout import OutgoingMailup
from quotient.mimemessage import EmailPowerup
from quotient.grabbers import GrabberPowerup
from quotient.searchup import Searchup
from quotient.cleanup import Cleanup, Ruler, Spambayesup
from quotient.prefup import Prefup
from quotient.voiceup import Voiceup
from quotient.web.webup import WebPowerup
from quotient.proto.popup import Popup
from quotient.gcup import GarbageCollector
#from quotient.tasks import Taskmaster
from quotient.signup import TicketIssuer
from quotient.provisioner import Provisioner
from quotient.smarts.question import QuestionCollector
from quotient.smarts.phone import PhoneNumberCollector
from quotient.smarts.url import URLCollector
from quotient.smarts.image import ImageCollector
from quotient.smarts.person import PersonCollector
from quotient.smarts.attachment import AttachmentCollector
from quotient.smarts.list import MailingListFiler
from quotient.smarts.list import Router
from quotient.blogup import BlogUp
from quotient.gradeup import Gradeup
from quotient.sysup import Adminup, ControlPanel
from quotient.addressbook import AddressBook
from quotient.smarts.todo import Notebook, TodoList
from quotient.smartenup import Smartenup
from quotient.backup import Backup
from quotient.meterer import Meterup, MeterStoreup
from quotient.serveup import ServeupPowerup, Serveup
from quotient.configure import Configup
from quotient.traceup import Traceup
from quotient.sumup import Summary

from quotient.application import DivmodApp, MailApp, VoiceApp, ChatApp
from quotient.application import PeopleApp, AlbumApp, CalendarApp, TodoApp
from quotient.application import  FindApp, SettingsApp



# Temporary convenience
# Make sure that Configup is the last Powerup to load

ALL = (
    DivmodApp, MailApp, VoiceApp, ChatApp, PeopleApp,
    AlbumApp, CalendarApp, TodoApp, FindApp, SettingsApp,
    Prefup, GrabberPowerup, EmailPowerup, SubScheduler,
    GarbageCollector, MailingListFiler, Searchup, Gradeup,
    Popup, IMAPAccountUp, WebPowerup, Voiceup, OutgoingMailup,
    PersonCollector, TicketIssuer, Summary,
    QuestionCollector, PhoneNumberCollector, URLCollector,
    AttachmentCollector, AddressBook, Smartenup, Meterup,
    ImageCollector, Spambayesup, Ruler, Router,
    Configup
)

VISIBLE = (
    Prefup, Meterup,
    SubScheduler, TicketIssuer, Gradeup,
    GarbageCollector,  
)

##ALL = (
##    Prefup, GrabberPowerup, EmailPowerup, SubScheduler,
##    GarbageCollector, MailingListFiler,
##    Popup, IMAPAccountUp, WebPowerup, Voiceup, OutgoingMailup,
##    PersonCollector, TicketIssuer,
##    BlogUp, AttachmentCollector, AddressBook, Smartenup, Meterup,
##    ImageCollector, Ruler, Commander, Router,
##    Configup # Always last
##)
##
##VISIBLE = (
##    Prefup, GrabberPowerup, BlogUp, Meterup,
##    PersonCollector, TicketIssuer,
##    Ruler, GarbageCollector, OutgoingMailup,
##)
POWERUPS = [(pup, pup in VISIBLE) for pup in ALL]

# Only installed for users created on the command line
TAP_PUPS = [
    (Adminup, False),
    (ServeupPowerup, True),
    ]

STOREUPS = (StoreRealm, BoxOffice, ControlPanel, Backup,
            MeterStoreup, Serveup, Traceup)
