# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

from twisted.python.components import Adapter

from quotient.searchup import IIndexable
from email.Header import decode_header
class MMessageIndexer(Adapter):
    __implements__ = IIndexable
    def indexableData(self):
        """
        Return a dictionary or {field:value} for
        indexing and subsequent search by Lupy in Searchup.
        """
        D = {}
        D['type'] = 'email'
        subj, charset = decode_header(self.original.get('subject', ''))[0]
        if subj:
            D['subject']=subj.decode(charset or 'ascii')

        sender, charset = decode_header(self.original.get('from', ''))[0]
        if sender:
            D['sender']=sender.decode(charset or 'ascii')
        try:
            text = self.original.getTypedParts('text/plain','text/rtf').next()
            charset = text.get_charset().input_charset
            text = text.get_payload(decode=True).decode(charset or 'ascii', "replace")
        except StopIteration:
            text = None
        if text:
            D['text']=text
        return D

class TodoIndexer(Adapter):
    __implements__ = IIndexable

    def indexableData(self):
        return {'text':self.original.name}
    
