# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.


test_messages = [
"""To: testguy@testplace.test.thing
From: More@test.strings
Date: Fri, 29 Aug 2002 01:37:00 -0600
Message-ID: <this.string.is.unique.in.the.known.universe@but.what.about.the.unknown>
Content-Type: text/plain
Content-Length: short
Lines: 3

Here is
A few
Lines of content!
""",
"""Header-Followed-By-Tab-Instead-Of-Space:	A Tab Preceeds This String
Return-Path: <twisted-python-admin@twistedmatrix.com>
Delivered-To: exarkun@meson.dyndns.org
Received: from pyramid.twistedmatrix.com (adsl-64-123-27-105.dsl.austtx.swbell.net [64.123.27.105])
	by meson.dyndns.org (Postfix) with ESMTP id C8E6613E93
	for <exarkun@meson.dyndns.org>; Sun, 20 Oct 2002 15:46:37 -0400 (EDT)
Received: from localhost ([127.0.0.1] helo=pyramid.twistedmatrix.com)
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 183Lzd-0000Cx-00; Sun, 20 Oct 2002 14:44:09 -0500
Received: from rack.gnubian.org ([209.61.188.219])
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 183LzM-0000C3-00
	for <twisted-python@twistedmatrix.com>; Sun, 20 Oct 2002 14:43:52 -0500
Received: from localhost.localdomain (cs666980-243.satx.rr.com [66.69.80.243])
	(authenticated bits=0)
	by rack.gnubian.org (8.12.5/8.12.5/Debian-1) with ESMTP id g9KJpQsG013802
	for <twisted-python@twistedmatrix.com>; Sun, 20 Oct 2002 14:51:26 -0500
Subject: Re: [Twisted-Python] enterprise.row and two-way relationships
From: Justin Ryan <justin@gnubian.org>
To: twisted-python@twistedmatrix.com
In-Reply-To: <20021020185058.GA783@orcrist>
References: <1035069693.944.10.camel@qutang>  <20021020185058.GA783@orcrist>
Content-Type: multipart/signed; micalg=pgp-sha1; protocol="application/pgp-signature";
	boundary="=-7s/NEw7xLXyUeykx6FS7"
X-Mailer: Ximian Evolution 1.0.8 
Message-Id: <1035143074.872.5.camel@qutang>
Mime-Version: 1.0
Sender: twisted-python-admin@twistedmatrix.com
Errors-To: twisted-python-admin@twistedmatrix.com
X-BeenThere: twisted-python@twistedmatrix.com
X-Mailman-Version: 2.0.11
Precedence: bulk
Reply-To: twisted-python@twistedmatrix.com
List-Help: <mailto:twisted-python-request@twistedmatrix.com?subject=help>
List-Post: <mailto:twisted-python@twistedmatrix.com>
List-Subscribe: <http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python>,
	<mailto:twisted-python-request@twistedmatrix.com?subject=subscribe>
List-Id: Twisted Python discussion stuff <twisted-python.twistedmatrix.com>
List-Unsubscribe: <http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python>,
	<mailto:twisted-python-request@twistedmatrix.com?subject=unsubscribe>
List-Archive: <http://twistedmatrix.com/pipermail/twisted-python/>
Date: 20 Oct 2002 14:44:33 -0500


--=-7s/NEw7xLXyUeykx6FS7
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

On Sun, 2002-10-20 at 13:50, Ken Kennedy wrote:
> On Sat, Oct 19, 2002 at 06:21:32PM -0500, Justin Ryan wrote:
> > Hello..
> >=20
> > To solve this problem, I've got a 'rel' table which keeps relationships
> > between account ids and contact ids, so if I want all of the contacts
> > for account x I simply pull all of the rows out of the 'rel' table whos=
e
> > accountId is x, and then individually step through them and extract the
> > contacts with the corresponding accountIds..
> >=20
> > I don't think there is a problem with the way I'm doing this, or a
> > better way to do this (though I'd be tickled if someone could point me =
a
> > better way), but in any case there does not seem to be an (obvious) way
> > to handle this with RowObjects..
>=20
> It's a little unclear, but the "pull all of the rows out..and then
> individually step through them" seems to suggest you're making two
> queries to the db. If that's the case,then yeah, there's a better
> way. If you know the accountID (from some previous query), just join
> rel to contacts:
>=20
> "select contact_info from contacts inner join rel on (rel.contactid =3D
> contacts.contactid) where rel.accountid =3D whatever"=20
>=20
> If you only know account name info, use:
>=20
> "select contact_info from=20
>        accounts inner join rel on (rel.accountid =3D accounts.accountid)
>        inner join
>        contacts on (contacts.contactid=3Drel.contactid)
>        where account.accountname =3D 'whatever'
> "
>=20
> Either way, you should be getting back what you need in one
> query. Does that make sense?
>=20

Certainly.., and it's not that far off from what I was doing.. except it
does seem a bit off in that no info is actually being pulled from the
account table - and if it were, it would be pulled multiple times (if i
want to pull the account name and account id, and then a list of
contacts).

the big important question here is ('scuse my german)... *drumroll*

how the fuck do I do this with twisted.enterprise.row? ;)

Unfortunately, the documentation for row seems pretty sketchy and shows
a direct parent-child relationship (room->furniture)..

it seems very unimportant what the underlying SQL does if row is
supposed to abstract it anyway..

any idears?

Thanks again!

-Justin

--=-7s/NEw7xLXyUeykx6FS7
Content-Type: application/pgp-signature; name=signature.asc
Content-Description: This is a digitally signed message part

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.2.0 (GNU/Linux)

iD8DBQA9swehEdFoPd10Cu0RAqrmAKCVGb8Pm2eCu6xBwtZWcVHRJrPDQACeNyxg
vcvJ4p64gr2+8CVFo7+s+ng=
=I9yy
-----END PGP SIGNATURE-----

--=-7s/NEw7xLXyUeykx6FS7--


_______________________________________________
Twisted-Python mailing list
Twisted-Python@twistedmatrix.com
http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python
""",
"""Envelope-to: test@domain.tld
Received: from pool-138-88-80-171.res.east.verizon.net
	([138.88.80.171] helo=meson.dyndns.org ident=69gnV1Y3MozcsVOT)
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 181WHR-0002Rq-00
	for <test@domain.tld>; Tue, 15 Oct 2002 13:18:57 -0500
Received: by meson.dyndns.org (Postfix, from userid 1000)
	id 34DEB13E95; Tue, 15 Oct 2002 14:20:18 -0400 (EDT)
Date: Tue, 15 Oct 2002 14:20:18 -0400
From: Jp Calderone <exarkun@blargchoo.choo.choo.dyndns.org>
To: test@domain.tld
Subject: [user@address: My Cool Apartment!]
Message-ID: <20021015182018.GA11673@unique.oh.yea>
Mime-Version: 1.0
Content-Type: multipart/signed; micalg=x-unknown;
	protocol="application/pgp-signature"; boundary="24zk1gE8NUlDmwG9"
Content-Disposition: inline
User-Agent: Mutt/1.3.25i
Content-Length: 2003
Lines: 72
Status: RO
x-pop3-uid: 3dbf299600000017 twistedmatrix.com


--24zk1gE8NUlDmwG9
Content-Type: multipart/mixed; boundary="h31gzZEtNLTqOjlF"
Content-Disposition: inline


--h31gzZEtNLTqOjlF
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
Content-Transfer-Encoding: quoted-printable


--=20
   Know what I pray for? The strength to change what I can, the inability to
accept what I can't and the incapacity to tell the difference.    -- Calvin
--
 2:00pm up 147 days, 14:57, 4 users, load average: 0.00, 0.02, 0.00

--h31gzZEtNLTqOjlF
Content-Type: message/rfc822
Content-Disposition: inline

Return-Path: <dynamox@springstreet.com>
Delivered-To: thisuser@guy.wherever
Received: from mx1.springstreet.com (unknown [206.131.172.28])
	by meson.dyndns.org (Postfix) with ESMTP id E027314187
	for <exarkun@choo.choo.choo.dyndns.org>; Wed, 18 Sep 2002 00:27:14 -0400 (EDT)
Received: from app2.springstreet.com (app2.admin.springstreet.com
	[10.0.149.2])
	by mx1.springstreet.com (8.11.6/8.11.6) with ESMTP id g8I4RUe47820
	for <exarkun@xxxx.org>; Tue, 17 Sep 2002 21:27:30 -0700 (PDT)
	(envelope-from dynamox@springstreet.com)
Received: (from dynamox@localhost)
	by app2.springstreet.com (8.10.2+Sun/8.10.2) id g8I4RUb22565;
	Tue, 17 Sep 2002 21:27:30 -0700 (PDT)
Date: Tue, 17 Sep 2002 21:27:30 -0700 (PDT)
Message-Id: <200209180427.g8I4RUb22565@app2.springstreet.com>
To: this.field.is.for@the.user.it.is.for
From: someuser@anotherdomain.com
SUBJECT: My Cool Apartment!

jp,

Hey! Check out this great apartment I found at Homestore.com apartments & 
rentals! You can visit it here:
http://www.springstreet.com/propid/246774?source=1xxctb079


cathedral ceilings



<message id:1032323249933719>

--h31gzZEtNLTqOjlF--

--24zk1gE8NUlDmwG9
Content-Type: application/pgp-signature
Content-Disposition: inline

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1


-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.0.7 (GNU/Linux)

iD8DBQE9rFxhedcO2BJA+4YRAjZqAKC6jZcmEZu0tInRreBjTbFcIh7rfACdEDhZ
oTZw+Ovl1BvLcE+pK9VFxxY=
=Uds2
-----END PGP SIGNATURE-----

--24zk1gE8NUlDmwG9--
""",

"""Envelope-to: test@domain.tld
Received: from dsl093-082-039.wdc1.dsl.speakeasy.net ([66.93.82.39]
	helo=mail.wooz.org)
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 182wKl-0000fN-00; Sat, 19 Oct 2002 11:20:15 -0500
Received: by mail.wooz.org (Postfix, from userid 500)
	id CC5E31BF6E4; Sat, 19 Oct 2002 12:21:43 -0400 (EDT)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="OwHEpO+hOl"
Content-Transfer-Encoding: 7bit
Message-ID: <15793.34455.512573.39157@gargle.gargle.HOWL>
Date: Sat, 19 Oct 2002 12:21:43 -0400
To: Jp Calderone <test@domain.tld>
Cc: mailing.list@place.what
Subject: Re: nntp protocol supports moderated newsgroups?
References: <15791.12797.768063.913733@gargle.gargle.HOWL>
	<3DAF3453.4030306@twistedmatrix.com>
	<15791.13852.867292.398473@gargle.gargle.HOWL>
	<3DAF3952.4050707@twistedmatrix.com>
X-Mailer: VM 7.07 under 21.4 (patch 9) "Informed Management" XEmacs Lucid
From: user@name.tld
X-Attribution: BAW
X-Oblique-Strategy: Speaking children
X-Url: http://barry.wooz.org
Content-Length: 9389
Lines: 242
Status: RO
x-pop3-uid: 3dbf299600000020 twistedmatrix.com


--OwHEpO+hOl
Content-Type: text/plain; charset=us-ascii
Content-Description: message body text
Content-Transfer-Encoding: 7bit


>>>>> "JC" == Jp Calderone <test@domain.tld> writes:

    JC>  Hmm, twisted/news/database.py should have all the stuff it
    JC> needs already - maybe makeGroupSQL() will need to be modified
    JC> a bit so that twisted/tap/news.py can tell it which groups
    JC> should be moderated and which shouldn't.  twisted/tap/news.py
    JC> will probably have most of the action; it'll need code to let
    JC> the user specify moderated/unmoderated to mktap somehow, maybe
    JC> with another --groups parameter, or with some indicator in the
    JC> groups file.

    JC> Maybe it's time twisted.news got a *real* configuration
    JC> interface :) I'll ponder that a little (maybe something fun
    JC> with woven), and if you(/anyone else) have any ideas on this,
    JC> I'd love to hear them.

I don't really, since I'm fairly green in my Twisted use.  I will note
that the news stuff seems a little more difficult to use than when I
last looked at it (Twisted 0.19 I think).  I'm using Twisted from cvs
now, so it's possible this stuff is just in flux.

Specifically:

- What is the --servers switch for?  I couldn't actually find where
  that was used in tap/news.py but it seemed required, so I fed it
  nonsense. 

- I understand why "mktap news" requires an extra argument now, but it
  would be nice if either the pickle or sql command were defaulted.  I
  don't think I needed to specify "mktap news pickle" last time.  Hmm,
  maybe if --file is given you can default to pickle?

- I noticed some bugs in the code, a few of which I fixed, but some I
  didn't.  I ran the server w/ twistd -n and watched the output.  I
  got mysterious log messages such as:

[...]
19/10/2002 11:54 [*news*] Starting factory <twisted.news.news.UsenetClientFactory instance at 0x82a52d4>
19/10/2002 11:54 [*news*] Connection failed: [Failure instance: Traceback! exceptions.IOError, address not found
19/10/2002 11:54 [*news*] ]
19/10/2002 11:54 [*news*] Connection failed: [Failure instance: Traceback! exceptions.IOError, address not found
19/10/2002 11:54 [*news*] ]
19/10/2002 11:54 [*news*] Stopping factory <twisted.news.news.UsenetClientFactory instance at 0x82a52d4>
19/10/2002 11:55 [*news*] Starting factory <twisted.news.news.UsenetClientFactory instance at 0x82a52d4>
[...]

  While these repeated as long as the server was running, they didn't
  seem to affect its operation.

- In news/news.py, buildProtocol() is trying to pass self.remoteHosts
  to the self.protocol() call, but self.protocol() -- which is really
  the nntp.NNTPServer class, doesn't take two arguments.

In any event, I hacked in moderated group support by adding a
-m/--moderators flag, which takes a file containing a list of
newsgroup/moderator address pairs.  When a message is POSTed to a
group, the list of target newsgroups is checked against the
moderators.  If there is any match, and the article has no Approved
header, the article is not posted, but instead emailed to the
moderators address.  The value of the Approved header is completely
ignored -- it just has to be there.  I believe this is pretty close to
how Usenet s/w handles moderators.

A couple of kludges that should be cleaned up:

- What to do if the list of target newsgroups has more than one
  moderated newsgroup in it?  Off hand, I'm not sure what Usenet does
  in this case.

- We really need a few more config options, including the smtp host
  and port to use to send out the moderator's email, and the envelope
  sender address to use in that email.  Both are hard coded in my
  hack.

- Any un-Twisted coding offenses. :)

So, in the grand tradition of scratching my own itch, but just enough
so I can sleep, here's the patch.

Oh, BTW, for someone who was completely green to the code base,
Twisted is very nicely written.  It wasn't difficult at all to drill
down to where I needed to make the changes.  JP's hints helped a lot
too.  Yay!

Enjoy,
-Barry


--OwHEpO+hOl
Content-Type: text/plain
Content-Description: Patch to Twisted news for moderation support
Content-Disposition: inline;
	filename="twisted.txt"
Content-Transfer-Encoding: 7bit

Index: twisted/news/database.py
===================================================================
RCS file: /cvs/Twisted/twisted/news/database.py,v
retrieving revision 1.15
diff -u -r1.15 database.py
--- twisted/news/database.py	3 Oct 2002 14:40:32 -0000	1.15
+++ twisted/news/database.py	19 Oct 2002 15:54:26 -0000
@@ -34,6 +34,7 @@
 from twisted.persisted import dirdbm
 
 import getpass, pickle, time, socket, md5, string
+import smtplib
 
 ERR_NOGROUP, ERR_NOARTICLE = range(2, 4)  # XXX - put NNTP values here (I guess?)
 
@@ -221,9 +222,9 @@
 
     sharedDBs = {}
 
-    def __init__(self, filename, groups = None):
+    def __init__(self, filename, groups = None, moderators = None):
         self.datafile = filename
-        self.load(filename, groups)
+        self.load(filename, groups, moderators)
 
     def listRequest(self):
         "Returns a list of 4-tuples: (name, max index, min index, flags)"
@@ -235,7 +236,10 @@
                 high = max(self.db[i].keys()) + 1
             else:
                 low = high = 0
-            flags = 'y'
+            if self.db['moderators'].has_key(i):
+                flags = 'm'
+            else:
+                flags = 'y'
             r.append((i, high, low, flags))
         return defer.succeed(r)
 
@@ -250,6 +254,25 @@
         groups = string.split(a.getHeader('Newsgroups'))
         xref = []
 
+        # first see if any groups are moderated.  if so, nothing gets posted,
+        # but the whole messages gets forwarded to the moderator address
+        moderator = None
+        for group in groups:
+            moderator = self.db['moderators'].get(group)
+            if moderator:
+                break
+        # Moderated postings go through as long as they have an Approved
+        # header, regardless of what the value is
+        if moderator and not a.getHeader('Approved'):
+            a.putHeader('To', moderator)
+            s = smtplib.SMTP()
+            s.connect()
+            s.sendmail('twisted@%s' % socket.gethostname(),
+                       [moderator],
+                       a.textHeaders() + a.body)
+            s.quit()
+            return defer.succeed(None)
+
         for group in groups:
             if self.db.has_key(group):
                 if len(self.db[group].keys()):
@@ -360,7 +383,7 @@
         pickle.dump(self.db, open(self.datafile, 'w'))
 
 
-    def load(self, filename, groups = None):
+    def load(self, filename, groups = None, moderators = None):
         if PickleStorage.sharedDBs.has_key(filename):
             self.db = PickleStorage.sharedDBs[filename]
         else:
@@ -373,6 +396,11 @@
                 if groups is not None:
                     for i in groups:
                         self.db[i] = {}
+                if moderators is not None:
+                    dmod = {}
+                    for g, m in moderators:
+                        dmod[g] = m
+                    self.db['moderators'] = dmod
                 self.flush()
 
 
Index: twisted/news/news.py
===================================================================
RCS file: /cvs/Twisted/twisted/news/news.py,v
retrieving revision 1.8
diff -u -r1.8 news.py
--- twisted/news/news.py	16 Oct 2002 04:27:39 -0000	1.8
+++ twisted/news/news.py	19 Oct 2002 15:54:26 -0000
@@ -89,7 +89,7 @@
 
 
     def buildProtocol(self, connection):
-        p = self.protocol(self.remoteHosts)
+        p = self.protocol()
         p.factory = self
         return p
 
Index: twisted/tap/news.py
===================================================================
RCS file: /cvs/Twisted/twisted/tap/news.py,v
retrieving revision 1.10
diff -u -r1.10 news.py
--- twisted/tap/news.py	8 Oct 2002 15:53:51 -0000	1.10
+++ twisted/tap/news.py	19 Oct 2002 15:54:26 -0000
@@ -62,15 +62,23 @@
 
         # XXX - Hrm.
         ["groups",     "g", "groups.list",   "File containing group list"],
-        ["servers",    "s", "servers.list",  "File containing server list"]
+        ["servers",    "s", "servers.list",  "File containing server list"],
+        ["moderators", "m", "moderators.list",
+         "File containing moderators list"],
     ]
 
     def postOptions(self):
         # XXX - Hmmm.
-        self['groups'] = [g.strip() for g in open(self['groups']).readlines() if not g.startswith('#')]
-        self['servers'] = [s.strip() for s in open(self['servers']).readlines() if not s.startswith('#')]
-
-        self.db = database.PickleStorage(filename, self['groups'])
+        filename = self['file']
+        self['groups'] = [g.strip() for g in open(self['groups']).readlines()
+                          if not g.startswith('#')]
+        self['servers'] = [s.strip() for s in open(self['servers']).readlines()
+                           if not s.startswith('#')]
+        self['moderators'] = [s.split()
+                              for s in open(self['moderators']).readlines()
+                              if not s.startswith('#')]
+        self.db = database.PickleStorage(filename, self['groups'],
+                                         self['moderators'])
 
 
 class Options(usage.Options):

--OwHEpO+hOl--
""",

"""Envelope-to: test@domain.tld
Received: from usw-sf-sshgate.sourceforge.net ([216.136.171.253]
	helo=usw-sf-netmisc.sourceforge.net)
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 183ySu-0007l4-00
	for <test@domain.tld>; Tue, 22 Oct 2002 07:48:56 -0500
Received: from usw-sf-web4-b.sourceforge.net ([10.3.1.24]
	helo=usw-sf-web4.sourceforge.net)
	by usw-sf-netmisc.sourceforge.net with esmtp (Exim 3.22 #1 (Debian))
	id 183yUx-0006tG-00
	for <test@domain.tld>; Tue, 22 Oct 2002 05:51:03 -0700
Received: from nobody by usw-sf-web4.sourceforge.net with local (Exim 3.33 #1
	(Debian))	id 183yUx-0005SN-00
	for <test@domain.tld>; Tue, 22 Oct 2002 05:51:03 -0700
To: test@domain.tld
Subject: SourceForge Project Approved
From: noreply@sourceforge.net
Message-Id: <E183yUx-0005SN-00@usw-sf-web4.sourceforge.net>
Date: Tue, 22 Oct 2002 05:51:03 -0700
Content-Length: 1914
Lines: 42
Status: RO
x-pop3-uid: 3dbf29960000002b twistedmatrix.com

Your project registration for SourceForge has been approved. 

Project Full Name:  Pynfo - Python IRC bot
Project Unix Name:  pynfo
CVS Server:         cvs.pynfo.sourceforge.net
Shell/Web Server:   pynfo.sourceforge.net

Your DNS will take up to a day to become active on our site.
While waiting for your DNS to resolve, you may try shelling into 
shell.sourceforge.net and pointing CVS to cvs.sourceforge.net.

If after 6 hours your shell/CVS accounts still do not work, please
open a support ticket so that we may take a look at the problem.
Please note that all shell/CVS accounts are closed to telnet and only
work with SSH1.

Your web site is accessible through your shell account. Please read
site documentation (see link below) about intended usage, available 
services, and directory layout of the account.

Please take some time to read the site documentation about project
administration (http://sourceforge.net/docs/site/). If you visit your 
own project page in SourceForge while logged in, you will find 
additional menu functions to your left labeled 'Project Admin'. 

We highly suggest that you now visit SourceForge and create a public
description for your project. This can be done by visiting your project
page while logged in, and selecting 'Project Admin' from the menus
on the left (or by visiting https://sourceforge.net/project/admin/?group_id=65337
after login).

Your project will also not appear in the Trove Software Map (primary
list of projects hosted on SourceForge which offers great flexibility in
browsing and search) until you categorize it in the project administration 
screens. So that people can find your project, you should do this now. 
Visit your project while logged in, and select 'Project Admin' from the 
menus on the left.

Enjoy the system, and please tell others about SourceForge. Let us know
if there is anything we can do to help you.

 -- the SourceForge crew
""",
"""Return-Path: <twisted-python-admin@twistedmatrix.com>
Delivered-To: exarkun@meson.dyndns.org
Received: from pyramid.twistedmatrix.com (adsl-64-123-27-105.dsl.austtx.swbell.net [64.123.27.105])
	by meson.dyndns.org (Postfix) with ESMTP id BF1081414A
	for <exarkun@meson.dyndns.org>; Fri, 23 Aug 2002 07:50:16 -0400 (EDT)
Received: from localhost ([127.0.0.1] helo=pyramid.twistedmatrix.com)
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 17iCgf-0001Eg-00; Fri, 23 Aug 2002 06:33:09 -0500
Received: from 209-189-198-108.puremagic.com ([209.189.198.108] helo=bellevue.puremagic.com)
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 17iCg4-0001EI-00
	for <twisted-python@twistedmatrix.com>; Fri, 23 Aug 2002 06:32:32 -0500
Received: from cubik.org (dnvrdslgw17poolb218.dnvr.uswest.net [63.231.84.218])
	by bellevue.puremagic.com (8.12.5/8.12.5/Debian-1) with ESMTP id g7NBnRnJ012012
	for <twisted-python@twistedmatrix.com>; Fri, 23 Aug 2002 04:49:27 -0700
Message-ID: <3D66221C.90802@cubik.org>
From: Bruce Mitchener <bruce@cubik.org>
User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.0rc2) Gecko/20020510
X-Accept-Language: en-us, en
MIME-Version: 1.0
To: twisted-python@twistedmatrix.com
Subject: Re: [Twisted-Python] epydoc and Twisted
References: <3D650A6B.6060606@cubik.org>	<1030039417.7568.2.camel@radii>	<3D6529A1.6060007@cubik.org> <20020823.003547.126575962.glyph@twistedmatrix.com>
Content-Type: text/plain; charset=us-ascii; format=flowed
Content-Transfer-Encoding: 7bit
X-Virus-Scanned: by amavisd-milter (http://amavis.org/)
Sender: twisted-python-admin@twistedmatrix.com
Errors-To: twisted-python-admin@twistedmatrix.com
X-BeenThere: twisted-python@twistedmatrix.com
X-Mailman-Version: 2.0.11
Precedence: bulk
Reply-To: twisted-python@twistedmatrix.com
List-Help: <mailto:twisted-python-request@twistedmatrix.com?subject=help>
List-Post: <mailto:twisted-python@twistedmatrix.com>
List-Subscribe: <http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python>,
	<mailto:twisted-python-request@twistedmatrix.com?subject=subscribe>
List-Id: Twisted Python discussion stuff <twisted-python.twistedmatrix.com>
List-Unsubscribe: <http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python>,
	<mailto:twisted-python-request@twistedmatrix.com?subject=unsubscribe>
List-Archive: <http://twistedmatrix.com/pipermail/twisted-python/>
Date: Fri, 23 Aug 2002 05:53:00 -0600

Glyph Lefkowitz wrote:
> "It's not just a good idea, it's the law."
> 
> This should be in the coding standard.  While I wouldn't take a lot of
> developer time that might be better spent elsewhere to go through and insert
> this meta-information, we really ought to be getting the most out of the
> documentation system we use.

Good good.  I'll make those changes to the standards.

> We should also write a silly hack to allow any module to import without
> ImportErrors.  I think this would fix most of the doc generation issues?

This takes more Python clue than I'v currently been gifted with. :) I'll 
see about scaring up some work out of dash, radix, itamar, or some other 
local smartie.

  - Bruce


_______________________________________________
Twisted-Python mailing list
Twisted-Python@twistedmatrix.com
http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python
""",
"""From: Exar Kun <exarkun@blargchoo.choo.choo.dyndns.org>
To: test@example.com
Date: Fri, 29 Aug 2002 01:37:10 -0600
Subject: test

More tests!
""",
"""To: testguy@testplace.test.thing
From: Test User <More@test.strings>
Date: Fri, 29 Aug 2002 01:37:20 -0600
Message-ID: <this.string.is.unique.in.the.known.universe@but.what.about.the.unknown.1>
Content-Type: text/plain
Content-Length: short
Lines: 3

Here is
A few
Lines of content!
""",
"""To: testguy@testplace.test.thing
From: Test User <More@test.strings>
Date: Fri, 29 Aug 2002 01:37:21 -0600
Message-ID: <this.string.is.unique.in.the.known.universe@but.what.about.the.unknown.2>
Content-Type: text/plain
Content-Length: short
Lines: 3

Here is
A few
Lines of content!
""",
"""Return-Path: <twisted-python-admin@twistedmatrix.com>
Delivered-To: exarkun@meson.dyndns.org
Received: from pyramid.twistedmatrix.com (adsl-64-123-27-105.dsl.austtx.swbell.net [64.123.27.105])
	by meson.dyndns.org (Postfix) with ESMTP id DD9521414A
	for <exarkun@meson.dyndns.org>; Sat, 24 Aug 2002 22:35:33 -0400 (EDT)
Received: from localhost ([127.0.0.1] helo=pyramid.twistedmatrix.com)
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 17imyb-0004YG-00; Sat, 24 Aug 2002 21:18:05 -0500
Received: from adsl-64-123-27-105.dsl.austtx.swbell.net ([64.123.27.105] helo=localhost.localdomain)
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 17imy5-0004XN-00
	for <twisted-python@twistedmatrix.com>; Sat, 24 Aug 2002 21:17:34 -0500
Subject: RE: [Twisted-Python] Proposed Website Comp
From: Christopher Armstrong <radix@twistedmatrix.com>
To: Twisted ML <twisted-python@twistedmatrix.com>
In-Reply-To:
	<!~!UENERkVCMDkAAQACAAAAAAAAAAAAAAAAABgAAAAAAAAA/oXuKv271EyqITBPzRe8l8KAAAAQ
	AAAASj9Jwy6e0UiuLYNHY9WcJwEAAAAA@markrichman.com>
References:
	<!~!UENERkVCMDkAAQACAAAAAAAAAAAAAAAAABgAAAAAAAAA/oXuKv271EyqITBPzRe8l8KAAAAQ
	AAAASj9Jwy6e0UiuLYNHY9WcJwEAAAAA@markrichman.com>
Content-Type: multipart/signed; micalg=pgp-sha1; protocol="application/pgp-signature";
	boundary="=-y4K5gnrIV2V16RyUNv7t"
X-Mailer: Ximian Evolution 1.0.8 
Message-Id: <1030242925.2584.34.camel@radii>
Mime-Version: 1.0
Sender: twisted-python-admin@twistedmatrix.com
Errors-To: twisted-python-admin@twistedmatrix.com
X-BeenThere: twisted-python@twistedmatrix.com
X-Mailman-Version: 2.0.11
Precedence: bulk
Reply-To: twisted-python@twistedmatrix.com
List-Help: <mailto:twisted-python-request@twistedmatrix.com?subject=help>
List-Post: <mailto:twisted-python@twistedmatrix.com>
List-Subscribe: <http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python>,
	<mailto:twisted-python-request@twistedmatrix.com?subject=subscribe>
List-Id: Twisted Python discussion stuff <twisted-python.twistedmatrix.com>
List-Unsubscribe: <http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python>,
	<mailto:twisted-python-request@twistedmatrix.com?subject=unsubscribe>
List-Archive: <http://twistedmatrix.com/pipermail/twisted-python/>
Date: 24 Aug 2002 22:35:17 -0400


--=-y4K5gnrIV2V16RyUNv7t
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

On Sat, 2002-08-24 at 22:12, Mark A. Richman wrote:
> This is why I called it a "comp" - I'm not going to waste my time with
> "real" HTML, CSS, etc. if you aren't going to like it...which you have
> made abundantly clear.

I think you got the wrong idea -- glyph did say that it was visually
pleasing (or something similar). It was only technical things that he
had criticisms for, and I agree with him full-heartedly. I think it's
sexy as well, it just needs to be hacked on to be not so blatantly
platform-dependant.

> I simply created it as a springboard for discussion, and not as a beta
> of any kind.

I think it looks awesome, but I agree with glyph's points. Is there any
chance you'll address some of the points he made? I can't say I'll be
able to help much, but I'd like to (and surely others would be able to
lend a hand here and there).

[snip to glyph...]
> > * You're using tables for all formatting, rather than CSS.  This is a
> > notorious
> > error that most experienced web designers seem to shudder at.  I guess
> > this

I thought this point was funny, considering the existing site uses
tables for formatting as well ;-)

--=20
                                Chris Armstrong
                         << radix@twistedmatrix.com >>
                http://twistedmatrix.com/users/radix.twistd/

--=-y4K5gnrIV2V16RyUNv7t
Content-Type: application/pgp-signature; name=signature.asc
Content-Description: This is a digitally signed message part

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.0.7 (GNU/Linux)

iD8DBQA9aEJlNp279O1/OG4RAsyXAJoDtYNw7sc41rB1Yts4GY1m9oUYKQCfShfi
zJW9/3um7dqmKB1HsPhLnGw=
=N4i2
-----END PGP SIGNATURE-----

--=-y4K5gnrIV2V16RyUNv7t--


_______________________________________________
Twisted-Python mailing list
Twisted-Python@twistedmatrix.com
http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python
""",
'''Delivered-To: exarkun@intarweb.us
Received: from intarweb.us [138.88.167.159]
	by localhost with POP3 (fetchmail-5.9.11)
	for exarkun@localhost (single-drop); Fri, 10 Oct 2003 19:46:51 -0400 (EDT)
Received: from tesla.divmod.net ([204.91.10.94] helo=tesla.divmod.net)
	by meson.intarweb.us with esmtp (Twisted 1.0.8alpha3)
	for exarkun@intarweb.us; Fri, 10 Oct 2003 19:43:47 -0400
Received: from tesla.divmod.net ([204.91.10.94])
	by tesla.divmod.net with esmtp (Exim 3.35 #1 (Debian))
	id 1A86rM-0008PA-00; Fri, 10 Oct 2003 19:39:48 -0400
Content-Type: multipart/mixed;
    boundary="204.91.10.94.1010.32311.1065829187.320.11216"
Subject: [issue369] Bug: Clicking on inbox
To: dp@divmod.org, exarkun@intarweb.us, glyph@twistedmatrix.com
From: Amir <quotient.roundup@divmod.org>
Reply-To: Divmod Quotient issue tracker <quotient.roundup@divmod.org>
Date: Fri, 10 Oct 2003 23:39:47 +0000
MIME-Version: 1.0
Message-Id: <1065829187.32.0.739568817215.issue369@divmod.org>
X-Roundup-Name: Divmod Quotient issue tracker
X-Roundup-Loop: hello
X-Bogosity: No, tests=bogofilter, spamicity=0.000000, version=0.15.4
Content-Length: 46737


--204.91.10.94.1010.32311.1065829187.320.11216
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable


New submission from Amir <amir@divmod.org>:

I started Quotient.
Started grabbing mail.
Compose an email.
Sent it. No error.
Went to look at outbox and got the attached excpetion.

----------
assignedto: exarkun
files: outbox.html
messages: 897
nosy: amir, dp, exarkun, glyph
priority: critical
status: unread
title: Bug: Clicking on inbox
___________________________________________________________
Divmod Quotient issue tracker <quotient.roundup@divmod.org>
<http://divmod.org/users/roundup.twistd/quotient/issue369>
___________________________________________________________
--204.91.10.94.1010.32311.1065829187.320.11216
Content-Type: text/html
Content-Disposition: attachment;
    filename="outbox.html"
Content-Transfer-Encoding: base64
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=

--204.91.10.94.1010.32311.1065829187.320.11216--

''',

'''>From glyph  Tue Jan 27 11:00:44 2004
Received: from fuchsia.puzzling.org ([212.13.199.233] helo=puzzling.org)
        by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
        id 1AlVdr-0002oK-00
        for <glyph@pyramid.twistedmatrix.com>; Tue, 27 Jan 2004 11:00:44 -0500
Received: from pacific-carrier-annex.mit.edu (PACIFIC-CARRIER-ANNEX.MIT.EDU [18.7.21.83])
        by puzzling.org (Postfix) with ESMTP id 7AE61112BF
        for <glyph@twistedmatrix.com>; Tue, 27 Jan 2004 17:49:09 +1100 (EST)
Received: from central-city-carrier-station.mit.edu (CENTRAL-CITY-CARRIER-STATION.MIT.EDU [18.7.7.72])
        by pacific-carrier-annex.mit.edu (8.12.4/8.9.2) with ESMTP id i0R6mtvj016027
        for <glyph@twistedmatrix.com>; Tue, 27 Jan 2004 01:48:55 -0500 (EST)
Received: from melbourne-city-street.mit.edu (MELBOURNE-CITY-STREET.MIT.EDU [18.7.21.86])
        by central-city-carrier-station.mit.edu (8.12.4/8.9.2) with ESMTP id i0R6msNF014215
        for <glyph@twistedmatrix.com>; Tue, 27 Jan 2004 01:48:55 -0500 (EST)
Received: from media.mit.edu (h00010296f714.ne.client2.attbi.com [65.96.164.224])
        )
        by melbourne-city-street.mit.edu (8.12.4/8.12.4) with ESMTP id i0R6msRj006786
        for <glyph@twistedmatrix.com>; Tue, 27 Jan 2004 01:48:54 -0500 (EST)
Message-ID: <401609D9.5020602@media.mit.edu>
Date: Tue, 27 Jan 2004 01:48:57 -0500
From: r <raffi@media.mit.edu>
User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.6b) Gecko/20031205 Thunderbird/0.4
X-Accept-Language: en-us, en
MIME-Version: 1.0
To: Glyph Lefkowitz <glyph@twistedmatrix.com>
Subject: Re: who is "itamar shtull-trauring"?
References: <2BD6B024-4C0D-11D8-BE62-0003939F1092@media.mit.edu> <40160926.7070209@twistedmatrix.com>
In-Reply-To: <40160926.7070209@twistedmatrix.com>
Content-Type: text/plain; charset=us-ascii; format=flowed
Content-Transfer-Encoding: 7bit
Status: RO

he\'s giving a talk at e-tech about developing using twisted.
 
> demigod of the twistedverse.  at one point, my 2nd in command, still
> nominally so, but at this point the de-facto project leader.
>
> why?
''',
"""X-Bodyless-Message: I Am Malformed
""",
]

html_messages = ['''\
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML><HEAD><TITLE></TITLE>
<META http-equiv=Content-Type content="text/html; charset=iso-8859-1">
<META content="MSHTML 6.00.2800.1170" name=GENERATOR>
<STYLE></STYLE>
</HEAD>
<BODY bgColor=#ffffff>
<DIV><FONT face=Arial size=2>Oops!</FONT></DIV>
<DIV><FONT face=Arial size=2>Yes, thanks Wouter, I did :-)</FONT></DIV>
<DIV><FONT face=Arial size=2></FONT>&nbsp;</DIV>
<BLOCKQUOTE dir=ltr 
style="PADDING-RIGHT: 0px; PADDING-LEFT: 5px; MARGIN-LEFT: 5px; BORDER-LEFT: #000000 2px solid; MARGIN-RIGHT: 0px">
  <DIV style="FONT: 10pt arial">----- Original Message ----- </DIV>
  <DIV 
  style="BACKGROUND: #e4e4e4; FONT: 10pt arial; font-color: black"><B>From:</B> 
  <A title=mmunge@address href="mailto:munge@address">Wouter van 
  Vliet</A> </DIV>
  <DIV style="FONT: 10pt arial"><B>To:</B> <A title=users@httpd.apache.org 
  href="mailto:users@httpd.apache.org">users@httpd.apache.org</A> </DIV>
  <DIV style="FONT: 10pt arial"><B>Sent:</B> Monday, November 10, 2003 5:40 
  PM</DIV>
  <DIV style="FONT: 10pt arial"><B>Subject:</B> RE: [users@httpd] 
.htaccess</DIV>
  <DIV><BR></DIV>
  <DIV dir=ltr align=left><FONT face=Arial color=#0000ff size=2><SPAN 
  class=343523617-10112003>Daniel probably meant: "<STRONG>note</STRONG> the 
  leading dot" instead of "not" .. it\'s kinda to very important 
  :P</SPAN></FONT></DIV><FONT face=Arial color=#0000ff size=2></FONT><BR>
  <BLOCKQUOTE 
  style="PADDING-LEFT: 5px; MARGIN-LEFT: 5px; BORDER-LEFT: #0000ff 2px solid; MARGIN-RIGHT: 0px">
    <DIV class=OutlookMessageHeader lang=en-us dir=ltr align=left>
    <HR tabIndex=-1>
    <FONT face=Tahoma size=2><B>From:</B> Daniel Clarke - JASWW 
    [mailto:another@munged] <BR><B>Sent:</B> maandag 10 november 2003 
    16:57<BR><B>To:</B> <A 
    href="mailto:users@httpd.apache.org">users@httpd.apache.org</A><BR><B>Subject:</B> 
    Re: [users@httpd] .htaccess<BR></FONT><BR></DIV>
    <DIV></DIV>
    <DIV><FONT face=Arial size=2>Hi Dayne</FONT></DIV>
    <DIV><FONT face=Arial><FONT size=2>Create a file called .htaccess (not the 
    leading dot) and put it in the directory that your customer 404 should apply 
    to.<SPAN class=343523617-10112003><FONT 
    color=#0000ff>&nbsp;</FONT></SPAN></FONT></FONT></DIV>
    <DIV><FONT face=Arial><FONT size=2><SPAN 
    class=343523617-10112003></SPAN></FONT></FONT><FONT face=Arial 
    size=2></FONT>&nbsp;</DIV>
    <DIV><FONT face=Arial size=2>In the file, put:</FONT></DIV>
    <DIV><FONT face=Arial size=2>&nbsp;&nbsp;&nbsp; &nbsp; ErrorDocument 404 
    /path/to/error404.html</FONT></DIV>
    <DIV><FONT face=Arial size=2>Note that the path to the error file has a 
    slash at the beginning</FONT></DIV>
    <DIV><FONT face=Arial size=2>You could also use</FONT></DIV>
    <DIV><FONT face=Arial size=2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ErrorDocument 
    404 /error404.html</FONT></DIV>
    <DIV><FONT face=Arial size=2></FONT>&nbsp;</DIV>
    <DIV><FONT face=Arial size=2>Note also that this error404.html should NOT 
    have any protection on it!</FONT></DIV>
    <DIV>&nbsp;</DIV>
    <DIV><FONT face=Arial size=2>Make sure that your ISP or sys admin has 
    allowed you to use custom .htaccess docs.</FONT></DIV>
    <DIV><FONT face=Arial size=2></FONT>&nbsp;</DIV>
    <BLOCKQUOTE 
    style="PADDING-RIGHT: 0px; PADDING-LEFT: 5px; MARGIN-LEFT: 5px; BORDER-LEFT: #000000 2px solid; MARGIN-RIGHT: 0px">
      <DIV style="FONT: 10pt arial">----- Original Message ----- </DIV>
      <DIV 
      style="BACKGROUND: #e4e4e4; FONT: 10pt arial; font-color: black"><B>From:</B> 
      <A title=more@munging href="mailto:away@munge">Dayne</A> </DIV>
      <DIV style="FONT: 10pt arial"><B>To:</B> <A title=users@httpd.apache.org 
      href="mailto:users@httpd.apache.org">users@httpd.apache.org</A> </DIV>
      <DIV style="FONT: 10pt arial"><B>Sent:</B> Sunday, November 09, 2003 8:28 
      PM</DIV>
      <DIV style="FONT: 10pt arial"><B>Subject:</B> [users@httpd] 
.htaccess</DIV>
      <DIV><BR></DIV><FONT size=2><FONT face=Arial,sans-serif>I\'m trying to make 
      custom 404 pages by making a .htaccess file.&nbsp; I reviewed the 
      documentation on .htaccess files on apache.org but now I\'m even more 
      confused than before.&nbsp; Can someone try to explain it 
      PLEASE!?!?<BR><BR>-Dayne<BR></FONT></FONT>--------------------------------------------------------------------- 
      The official User-To-User support forum of the Apache HTTP Server Project. 
      See <URL:HTTP: userslist.html httpd.apache.org>for more info. To 
      unsubscribe, e-mail: users-unsubscribe@httpd.apache.org " from the digest: 
      users-digest-unsubscribe@httpd.apache.org For additional commands, e-mail: 
      users-help@httpd.apache.org 
    </BLOCKQUOTE><BR>________________________________________________________________________<BR>This 
    email has been scanned for all viruses by MDaemon PRO v6.8.4 R<BR>on Mon, 10 
    Nov 2003 15:56:52 -0000 and found to contain no infected <BR>attachments. 
    The virus list was updated on Mon 2003-11-10 
    15:30:33<BR>________________________________________________________________________ 
  </BLOCKQUOTE></BLOCKQUOTE></BODY></HTML>


<html>
<br>
________________________________________________________________________<br>
This email has been scanned for all viruses by MDaemon PRO v6.8.4 R<br>
on Mon, 10 Nov 2003 17:47:30 -0000 and found to contain no infected <br>
attachments. The virus list was updated on Mon 2003-11-10 17:30:41<br>
________________________________________________________________________</html>
''',
]
