print "got this far"

import os, sys, os.path as osp
from os.path import join as opj
from twisted.trial import unittest
from twisted.python.util import sibpath

import quotient 
d = os.path.dirname(os.path.dirname(quotient.__file__))
if os.path.isfile(os.path.join(d, 'setup.py')):
    sys.path.insert(0, d)
    import setup
    sys.path.pop(0)
else:
     setup = None

class CheckingPackagesTestCase(unittest.TestCase):
    def setUpClass(self):
        self.ignoredirs = ['.svn', 'CVS', '_trial_temp'] # ;)

    def setUp(self):
        self.curDir = os.getcwd()

    def tearDown(self):
        os.chdir(self.curDir)

    def testPackages(self):
        """Making sure all packages are in setup"""
        if setup is None:
            raise unittest.SkipTest("no setup -- installed version?")
        foundPackages = []

        os.chdir(sibpath(setup.__file__, ''))

        dirlist = []
        for path, dirs, files in os.walk('.'):
            for name in self.ignoredirs:
                if name in dirs:
                    dirs.remove(name)
            if '__init__.py' in files:
                dirlist.append(path.lstrip('/.'))


        foundPackages = [x.replace(os.sep, '.') for x in dirlist]
        setupPackages = setup.setup_args['packages']

        print "foundPackages: %r" % foundPackages
        print "setupPackages: %r" % setupPackages
        
        missing = []
        for package in setupPackages:
            try:
                foundPackages.remove(package)
            except ValueError:
                missing.append(package)

        if missing:
            self.fail("Package(s) %r listed in setup.py but was not found in"
                      " the source tree." % missing)

        # Everything in foundPackages should have been removed by its match
        # in setupPackages, nothing should be left.
        self.failIf(foundPackages, "Packages found which are not in setup.py: "
                    "%s\n" % (foundPackages,))


