# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

from twisted.trial import unittest
from quotient.proto import twisted_sip as sip

from quotient.proto import sip as qsip

class LocatorTestCase(unittest.TestCase):
    def setUp(self):
        self.locator = qsip.MultiDomainRegistry(('domain1', '2domain'))
    
    def testAddDomain(self):
        L = self.locator
        
        L.addDomain("domain3")
        D = L.domains.keys()
        E = ["domain1", "2domain", "domain3"]
        D.sort()
        E.sort()
        self.assertEquals(D, E)
    
    def testRemoveDomain(self):
        L = self.locator
        L.removeDomain("domain1")
        self.assertEquals(L.domains.keys(), ["2domain"])
    
    def testDomainExists(self):
        self.failUnless(self.locator.domainExists("domain1"))
        self.failUnless(self.locator.domainExists("2domain"))
        self.failIf(self.locator.domainExists("domain3"))
