# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

from nevow.tags import *
from formless import webform

from twisted.web import resource


from quotient import provisioner
from quotient.functional import unittest as funit
from quotient.web.root import Base, TabularBase, column
from quotient.taglib import page, href

class DefaultPowerupDisplay(Base):
    document = page(title=lambda foo: foo.powerupName)[
        webform.renderForms()
        ]


class TabularPowerup(TabularBase):
    def render_name(self, context, data):
        name = getattr(data, 'name', None)
        return href(data)(id=funit.getIdAttr(context, name))[str(name)]
    column(render_name, True, 300)

    def render_status(self, context, data):
        return href(data)["Started"]
    column(render_status, True, 200)

class TabularProvisionedPowerup(TabularPowerup):
    def render_tank(self, context, data):
        av = context.locate(resource.IResource).avatar
        prov = provisioner.IProvisionable(data)
        return provisioner.IProvisioner(av).fueltanker.fuel[prov.tankID]
    column(render_tank, True, 50)
