# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.


from atop.powerup import Powerup

from nevow.rend import Page
from twisted.persisted.styles import Versioned
from quotient.mimemessage import EmailPowerup
from quotient.web.root import RootCrudMixin, Me, UserFrontPage, Quotient404
from nevow.inevow import IResource
from quotient.provisioner import ProvisionedPowerup

class WebPowerup(RootCrudMixin, ProvisionedPowerup, Page, Versioned):
    __implements__ = ProvisionedPowerup.__implements__, Page.__implements__
    powerupName = 'Web Login'

    toremember = []

    isLeaf = False
    persistenceVersion = 1
    def upgradeToVersion1(self):
        self.touch()
        from quotient.gradeup import Gradeup
        from atop.powerup import IPowerStation
        pm = IPowerStation(self.store)
        pm.installPowerup(Gradeup)

    def __init__(self, avatar):
        ProvisionedPowerup.__init__(self, avatar)
        Page.__init__(self)

    def setUpPools(self, avatar):
        avatar.setComponent(IResource, self)
        self.greyedOut = True
        self.invisible = True

    def logout(self):
        """
        Should probably do something here?
        """
        pass

    def child_(self, request):
        return UserFrontPage(self.store)

    def child_me(self, request):
        return Me(self.store)

    def locateChild(self, request, segments):
        request.rememberRootURL()
        return super(WebPowerup, self).locateChild(request, segments)

    def child_users(self, request):
        from quotient.public import UsersPage
        return UsersPage(self.store)

    def willHandle_notFound(self, request):
        return True

    def renderHTTP_notFound(self, request):
        return Quotient404(self.store).render(request)

    def child_givemeatraceback(self, request):
        raise RuntimeError("this is your traceback")
