
"""
Loads all objects in the store.
"""

from atop import store
from quotient import mimemessage

def someObjects(st, klass):
    topID = st.nextID(False)
    for i in xrange(topID):
        try:
            item = st.getItemByID(i)
        except KeyError:
            pass
        else:
            if isinstance(item, klass):
                yield item

def allObjects(st):
    for av in someObjects(st, (store.Item, store.SubStore)):
        if isinstance(av, store.SubStore):
            for obj in someObjects(av, store.Item):
                yield av, obj

def main():
    st = store.Store('../data/db', '../data/files')
    try:
        for (av, obj) in allObjects(st):
            pass
    finally:
        st.close()

if __name__ == '__main__':
    main()
