
"""
Loads all objects in the store and examines MIMEMessages for
missing x-divmod-processed headers.
"""

from atop import store
from quotient import mimemessage

def someObjects(st, klass):
    topID = st.nextID(False)
    for i in xrange(topID):
        try:
            item = st.getItemByID(i)
        except KeyError:
            pass
        else:
            if isinstance(item, klass):
                yield item

def allObjects(st):
    for av in someObjects(st, store.SubStore):
        for obj in someObjects(av, mimemessage.MIMEMessage):
            yield av, obj

def missingDate(st):
    print st.getItemByID(28).getItemByID(2818)
    for (av, obj) in allObjects(st):
        if obj['x-divmod-processed'] is None:
            print obj.getItemPath()


def main():
    st = store.Store('../data/db', '../data/files')
    try:
        missingDate(st)
    finally:
        st.close()

if __name__ == '__main__':
    main()
