#!/usr/bin/env python2.3
# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

import sys

from atop import store

from twisted.cred.checkers import ICredentialsChecker
from quotient.grabbers import IGrabberManager
from twisted.python import log

class FakeIO(object):
    def __getattr__(self, attr):
        if attr == 'write':
            return self._write
        else:
            return self
    
    def _write(self, data):
        print data


log.startLogging()

class GrabberPauser(object):
    def __init__(self, datadir="../data/db", filesdir="../data/files"):
        self.store = store.Store(datadir, filesdir)

    def close(self):
        if not self.store.closed:
            self.store.close()
    
    def _getAvatars(self):
        return self.store.transact(lambda :[a for a in ICredentialsChecker(st).getAvatars()])
    avatars = property(_getAvatars)

    def pauseGrabbers():
        pass


if __name__ == "__main__":
    gp = GrabberPauser()
##     try:
##         pass
##     finally:
##         gp.close()
