#!/usr/bin/python

import sys

from atop import store
from atop import credup

from twisted.python import usage

class Options(usage.Options):
    optParameters = [
        ["datadir", "d", "/home/staging/data/db", "Path to database directory"],
        ["filedir", "f", "/home/staging/data/files", "Path to auxillary file directory"],
        ["oldname", "o", "divmod.com", "Current name of domain to rename"],
        ["newname", "n", "divmod.org", "New name to give domain"]]

def renameDomain(st, oldName, newName):
    ps = credup.ICredentialsChecker(st)
    domain = ps.getDomain(oldName)
    domain.touch()
    domain.name = newName

def main(args=None):
    if args is None:
        args = sys.argv[1:]
    o = Options()
    try:
        o.parseOptions(args)
    except usage.UsageError, e:
        raise SystemExit(str(e))
    else:
        s = store.Store(o["datadir"], o["filedir"])
        try:
            s.transact(renameDomain, s, o["oldname"], o["newname"])
        finally:
            s.close()

if __name__ == '__main__':
    main()
