#!/bin/zsh 

projects="$HOME/Projects"
spambayes="spambayes-1.0a7"
spambayes_url="http://www.divmod.org/users/slyphon/$spambayes.tgz"
local_lib="$HOME/lib/python2.3/site-packages"

repo=svn+ssh://divmod.org/svn
exponent=$repo/Exponent
lupy=$repo/Lupy
pyndex=$repo/Pyndex
twisted=svn+ssh://svn.twistedmatrix.com/svn/Twisted
nevow=$repo/Nevow
reverend=$repo/Reverend
qtoolsrepo=$repo/QuotientTools

do_checkout() {
    if [[ ! -d $projects ]]; then
        echo "$projects doesn\'t exist, creating"
        mkdir $projects
    fi
    
    cd $projects

    for url dir in $exponent Exponent \
                   $lupy Lupy \
                   $pyndex Pyndex \
                   $twisted Twisted \
                   $nevow Nevow \
                   $reverend Reverend 
        do
            if [[ ! -d $dir ]]; then
                svn co $url/trunk $dir
            else
                cd $dir
                echo "Updating $dir"
                svn up
                cd ..
            fi
        done

    svn co $dqrepo/trunk $HOME/run
}

get_spambayes() {
    if [[ ! -d $projects/spambayes ]]; then
        cd $projects
        wget $spambayes_url
        tar -zxvf $spambayes.tgz
        mv $spambayes spambayes
        rm $spambayes.tgz
        cd ..
    fi
}

pysetup() { 
    python2.3 setup.py install --prefix ~
    if [[ -d build ]]; then
        rm -rf build/
    fi
}

install_others() {
    cwd=`pwd`
    cd $projects

    cd Exponent
    /bin/cp -a "exponent" "$local_lib"
    cd $cwd
}

run_pysetup() {
    print "Entered run_pysetup"
    cd $projects

    for dir in Lupy Pyndex Twisted Nevow Reverend spambayes
        do
            echo "installing $dir"
            installed_dir=$local_lib/${(L)dir} 
            if [[ -d $installed_dir ]]; then
                echo "removing original installation $installed_dir"
                rm -rf $installed_dir
            fi

            cd $dir
            pysetup
            cd ..
        done
    
    if [[ -d $local_lib/exponent ]]; then
        rm -rf $local_lib/exponent
    fi
}


do_checkout
get_spambayes
run_pysetup
install_others
